;Copyright 2014 Daniel Green, v1.00.0b modified 2/4/14 5:00am

;Vigenere+ is free for both business and personal use. It can be freely modified and redistributed providing that, 1. all notices remain intact, 2. you acknowledge where it originally came from, 3. it is only used for legal and ethical purposes, 4. no profit is derived from its distribution.

#notrayicon
#noenv
#singleinstance, ignore
setbatchlines, -1
setworkingdir, %a_scriptdir%

menu, tray, nostandard
menu, tray, tip, Vigenere+
menu, tray, add, Restore, win
menu, tray, add, About, about
menu, tray, add
menu, tray, add, Exit, guiclose
menu, tray, default, restore

menu, text, add, Load from file..., openfile
menu, text, add
menu, text, add, Save to file..., savetofile
menu, text, add, Save to clipboard, savetoclip
menu, text, icon, Load from file..., SHELL32.dll, 71, 16
menu, text, icon, Save to file..., SHELL32.dll, 71, 16
menu, text, icon, Save to clipboard, SHELL32.dll, 22, 16
menu, mainbar, add, File, :text
menu, mainbar, add, About, about
gui, menu, mainbar

gui, font, s8
gui, +resize +minsize
gui, add, groupbox, x10 y0 w350 h226 vgbxmain
gui, add, edit, vscroll x20 y16 w330 h170 vtext, 
gui, add, edit, x20 y196 w200 h20 vpass, 
gui, add, button, x230 y196 w60 h20 vbtnencipher gencipher, Encipher
gui, add, button, x290 y196 w60 h20 vbtndecipher gdecipher, Decipher

gui, show, w370 h236, Vigenere+
return

savetoclip:
 {
   gui, submit, nohide
   gui, +owndialogs
   if (text = "")
    {
      msgbox, 64, Save..., The text field is empty., 10
    }
   else
    {
      stringreplace, text, text, `n, `r`n, 1
      clipboard := text
      msgbox, 64, Save..., Your text has been saved to the clipboard., 10
    }
 }
return

savetofile:
 {
   gui, submit, nohide
   gui, +owndialogs
   if (text = "")
    {
      msgbox, 64, Save..., The text field is empty., 10
    }
   else
    {
      fileselectfile, path, s18, *.txt, Save to file..., (*.txt)
      if (path != "")
       {
         if fileexist(path)
          {
            filedelete, %path%
          }
         fileappend, %text%, %path%, utf-8
         splitpath, path, name
         msgbox, 64, Save..., Your text has been saved to "%name%"., 10
       }
    }
 }
return

openfile:
 {
   gui, +owndialogs
   fileselectfile, path, 3, *.txt, Open file..., (*.txt)
   fileread, content, %path%
   stringreplace, content, content, `r`n, `n, 1
   guicontrol, , text, %content%
 }
return

encipher:
 {
   gui, submit, nohide
   gui, +owndialogs
   if (text = "") && (pass = "")
    {
      msgbox, 64, Encipher..., Both fields are empty., 10
    }
   else if (text = "")
    {
      msgbox, 64, Encipher..., The text field is empty., 10
    }
   else if (pass = "")
    {
      msgbox, 64, Encipher..., The password field is empty., 10
    }
   else
    {
      stringreplace, text, text, `r`n, `n, 1
      if regexmatch(text, "[^`n -~]")
       {
         msgbox, 65, Unsupported characters..., There is one or more unsupported character in your text. They will be removed before continuing.
         ifmsgbox ok
          {
            text := regexreplace(text, "[^`n -~]")
          }
         else
          {
            return
          }
       }
      guicontrol, disable, text
      ciphertext := _encipher(text, _keygen(text, pass))
      guicontrol, enable, text
      guicontrol, , text, %ciphertext%
    }
 }
return

decipher:
 {
   gui, submit, nohide
   gui, +owndialogs
   if (text = "") && (pass = "")
    {
      msgbox, 64, Decipher..., Both fields are empty., 10
    }
   else if (text = "")
    {
      msgbox, 64, Decipher..., The text field is empty., 10
    }
   else if (pass = "")
    {
      msgbox, 64, Decipher..., The password field is empty., 10
    }
   else
    {
      stringreplace, text, text, `r`n, `n, 1
      if regexmatch(text, "[^`n -~]")
       {
         msgbox, 65, Unsupported characters..., There is one or more unsupported character in your text. They will be removed before continuing.
         ifmsgbox ok
          {
            text := regexreplace(text, "[^`n -~]")
          }
         else
          {
            return
          }
       }
      guicontrol, disable, text
      plaintext := _decipher(text, _keygen(text, pass))
      guicontrol, enable, text
      guicontrol, , text, %plaintext%
    }
 }
return

_encipher(text, key)
 {
   loop parse, text
    {
      a := _asc(a_loopfield)
      b := _asc(substr(key, mod(a_index, strlen(key)), 1))
      out .= _chr(mod(a + b, 100))
    }
   return out
 }
 
_decipher(text, key)
 {
   loop parse, key
    {
      decoderkey .= _chr(100 - _asc(a_loopfield))
    }
   return _encipher(text, decoderkey)
 }

_keygen(text, password)
 {
   seed := _hash(password)
   random, , seed
   loop, % strlen(text)
    {
      random, ran, 0, 99
      key .= _chr(ran)
    }
   return key
 }

_hash(string)
 {
   hash := 2166136261
   loop, parse, string
    {
      hash := 16777619 * (hash ^ asc(substr(string, a_index, 1)))
    }
   return hash & 0xFFFFFFFF
 }

_asc(input)
 {
   return input = "`n" ? 0 : input = "" ? 96 : input = "" ? 97 : input = "" ? 98 : input = "" ? 99 : asc(input) - asc(a_space) + 1
 }

_chr(input)
 {
   return input = 0 ? "`n" : input = 96 ? "" : input = 97 ? "" : input = 98 ? "" : input = 99 ? "" : chr(input + asc(a_space) - 1)
 }

about:
 {
   if (about_gui != 1)
    {
      gosub, get_about
      gui, font, s8
      gui, 2:add, button, x340 y275 w60 h20 ghome_site, Home
      gui, 2:add, button, default x400 y275 w60 h20 g2guiclose, OK
      gui, 2:add, edit, +readonly vscroll x10 y10 w450 h260, %about%
      gui, 2:show, center w470 h300, About Vigenere+
      about_gui := 1
    }
   else
    {
      gui, 2:destroy
      about_gui := 0
    }
 }
return

get_about:
 {
   about := 
(
"Vigenere+ v1.00.0b

Copyright 2014 Daniel Green

Vigenere+ is a text substitution cipher application meant for entertainment and educational purposes.

Vigenere+ is free for both business and personal use. It can be freely modified and redistributed providing that:
   1. All notices remain intact.
   2. You acknowledge where it originally came from.
   3. It is only used for legal and ethical purposes.
   4. No profit is derived from its distribution.

Features:
   Enciphers and deciphers text using a keyed Vigenere cipher with a 100 character cipher alphabet.
   Uses your passphrase to generate a pseudo random key equal in length to the plaintext.
   Portable, can run from removable media and makes no changes to the host system.
   Open source, written in AutoHotkey (http://www.autohotkey.com).

Instructions:
   Place English text in the edit box, supply a passphrase and click Encipher. To decipher repeat the process using the same passphrase and click Decipher. Keep in mind that only 100 common English characters are supported. If your text contains one or more unsupported characters you will be warned before continuing.

Disclaimer:
   Vigenere+ is NOT intended to provide any form of data security function. Vigenere+ is intended for entertainment and educational purposes only.
   Both the FNV1a hash and the Mersenne twister random number generator are very good, but they are not considered cryptographically secure. I used them because they were very convenient and easy to implement. Just think of Vigenere+ as the modern version of the decoder rings that used to come in cereal boxes. Fun, but not to be taken seriously.

Requirements:
   Windows XP - Win7

History:
   v1.00.0b
      Initial beta release.

Known bugs:
   None.

Thanks to:
   Several members of the autohotkey.com community for their help and advice in creating Vigenere+. In particular, nimda for providing the Vigenere code on which Vigenere+ is heavily based, and Skwire for providing advice and code for window resizing."
)
 }
return

home_site:
 {
   run, http://crzyinc.weebly.com/vigenere.html
 }
return

guisize:
 {
   gui, +owndialogs
   if (a_eventinfo = 1) && (flag != 1)
    {
      if (!set)
       {
         gui, restore
         msgbox, 35, Minimize..., Send window to the system tray?
       }
      flag := 1
      ifmsgbox yes
       {
         set := 1
       }
      ifmsgbox no
       {
         set := 2
       }
      if (set = 1)
       {
         gosub, win
       }
      else if (set = 2)
       {
         gui, minimize
       }
      sleep, 200
      flag := 0
    }
   else
    {
      anchor("gbxmain", "w h", 1)
      anchor("text", "w h", 1)
      anchor("pass", "y w", 1)    
      anchor("btnencipher", "x y", 1)
      anchor("btndecipher", "x y", 1)
    }
 }
return

win:
 {
   toggle := !toggle
   if (toggle)
    {
      gui hide
      menu, tray, icon
    }
   else
    {
      gui, show, center
      menu, tray, noicon
    }
 }
return

guiclose:
 {
   gui, show
   gui, submit, nohide
   gui, +owndialogs
   if (text != "") && (pass != "")
    {
      msgbox, 65, Close..., Text and password will be lost on exit.
    }
   else if (text != "")
    {
      msgbox, 65, Close..., Text will be lost on exit.
    }
   else if (pass != "")
    {
      msgbox, 65, Close..., Password will be lost on exit.
    }
   ifmsgbox cancel
    {
      return
    }
   exitapp
 }
return

2guiclose:
 {
   gui, 2:destroy
   about_gui := 0
 }
return

anchor(c, a = "", r = false)
 {
   static d
	 guicontrolget, p, pos, %c%
	 if ex := errorlevel
	  {
		  gui, %a_gui%:+lastfound
		  controlgetpos, px, py, pw, ph, %c%
	  }
	 if !(a_gui or px) and a
	  {
		  return
		}
	 i = x.w.y.h./.7.%a_guiwidth%.%a_guiheight%.`n%a_gui%:%c%=
	 stringsplit, i, i, .
	 d := a ? d . ((n := !instr(d, i9)) ? i9 : "") : regexreplace(d, "\n\d+:" . c . "=[\-\.\d\/]+")
	 loop, 4
	  {
	    x := a_index, j := i%x%, i6 += x = 3
		  , k := !regexmatch(a, j . "([\d.]+)", v) + (v1 ? v1 : 0)
		  , e := p%j% - i%i6% * k, d .= n ? e . i5 : ""
		  , regexmatch(d, "\Q" . i9 . "\E(?:([\d.\-]+)/){" . x . "}", v)
		  , l .= p%j% := instr(a, j) ? (ex ? "" : j) . v1 + i%i6% * k : ""
	  }
	if r
	 {
	   rx = draw
	 }
	if ex
	 {
	   controlmove, %c%, px, py, pw, ph
	 }
	else
	 {
	   guicontrol, move%rx%, %c%, %l%
	 }
 }